##############################################################################
#
# BernArticle - yet another Plone article...
#
# Copyright (C) 2005 4teamwork Ltd., Bern, Switzerland and
#                    Informatikdienste of the city of Bern, Switzerland
#
# GNU General Public Licence (GPL)
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307 USA
#
##############################################################################
from Products.CMFCore.utils import getToolByName,manage_addTool
from Products.CMFPlone.migrations.migration_util import safeEditProperty
from Products.CMFCore.DirectoryView import addDirectoryViews
from Products.ExternalMethod.ExternalMethod import ExternalMethod
from Products.CMFDynamicViewFTI.migrate import migrateFTIs

from Products.Archetypes.Extensions.utils import installTypes, install_subskin
from Products.Archetypes import listTypes
from Products.BernArticle.config import *
from Products.BernArticle.BernArticleRegistration import *

from StringIO import StringIO
import sys


####################################################################################################
def installPortlets(self, portal):
    right_slots = list(portal.getProperty('right_slots'))
    for portlet in RIGHT_SLOTS:
      if portlet not in right_slots:
          right_slots.insert(0, portlet)
    self.manage_changeProperties({'right_slots':tuple(right_slots)})
    
    
####################################################################################################
def installProperties(self):
    portal=getToolByName(self,'portal_url').getPortalObject()
    prop_tool = self.portal_properties
    if not hasattr(prop_tool, 'BernArticle_properties'):
        prop_tool.manage_addPropertySheet('BernArticle_properties', 'BernArticle properties')
        p=prop_tool.BernArticle_properties
        p._setProperty('BernArticle_width', '530'  , 'string')
        p._setProperty('BernArticle_image_space', '10', 'string')
        p._setProperty('BernArticle_fixed_image_height', '150', 'string')
        p._setProperty('BernArticle_startpageblock_width', '70', 'string')
        p._setProperty('BernArticle_types_for_collector', tuple(), 'lines')
        p._setProperty('BernArticle_folder_types', tuple(), 'lines')
        p._setProperty('BernArticle_types_for_search', tuple(), 'lines')
        p._setProperty('BernArticle_types_for_article_folder_contents', tuple(), 'lines')
        p._setProperty('BernArticle_article_types', tuple(), 'lines')
        p._setProperty('BernArticle_teaser_block_types', tuple(), 'lines')
        p._setProperty('BernArticle_block_types', tuple(), 'lines')
        p._setProperty('BernArticle_collector_types', tuple(), 'lines')


####################################################################################################
def install(self):
    portal = getToolByName(self,'portal_url').getPortalObject()
    out = StringIO()
    classes = listTypes(PROJECTNAME)

    installTypes(self, out, classes, PROJECTNAME)
    install_subskin(self, out, GLOBALS)

    # add our properties in portal_properties if they do not exist yet:
    installProperties(self)

    # register types:
    for type in BERNARTICLE_ARTICLE_TYPES + BERNARTICLE_BLOCK_TYPES + BERNARTICLE_COLLECTOR_TYPES:
        registerBernArticleType(self, type,
                                     isArticleType=(type in BERNARTICLE_ARTICLE_TYPES),
                                     isCollectorType=(type in BERNARTICLE_COLLECTOR_TYPES),
                                     isFolderType=(type in BERNARTICLE_FOLDER_TYPES),
                                     isTeaserType=(type in BERNARTICLE_TEASER_BLOCK_TYPES),
                                     isCalendarType=(type in BERNARTICLE_CALENDAR_TYPES),
                                     isHiddenFromNav=(type in HIDDEN_FROM_NAVIGATION_METATYPES),
                                     isInSearchResults=(type in BERNARTICLE_TYPES_FOR_SEARCH),
                                     isInCollectorResultsAndBlockLists=(type in BERNARTICLE_TYPES_FOR_COLLECTOR),
                                     isInFolderContents=(type in BERNARTICLE_TYPES_FOR_ARTICLE_FOLDER_CONTENTS),
                                     isLinkableKupuType=(type in KUPU_LINKABLE_TYPES)
                                    )                                    
                                                                                   
    # migrate FTIs to DynamicFTIs (in order to have dynmic view):
    migrateFTIs(self, product=PROJECTNAME)

    # install all the portlets:
    installPortlets(self, portal)

    print >> out, "Successfully installed %s." % PROJECTNAME

    return out.getvalue()


def uninstall(self):
    out = StringIO()
    classes = listTypes(PROJECTNAME)

    # unregister the types:
    for type in BERNARTICLE_ARTICLE_TYPES + BERNARTICLE_BLOCK_TYPES + BERNARTICLE_COLLECTOR_TYPES:
        unregisterBernArticleType(self, type)

    return out.getvalue()
