try:
    import CustomizationPolicy
except ImportError:
    CustomizationPolicy = None
    print 'no Customizationpolicy for BernArticle installed'

try:
    from Products.CMFPlone.interfaces import IPloneSiteRoot
    from Products.GenericSetup import EXTENSION, profile_registry
    HAS_GENERICSETUP = True
except ImportError:
    HAS_GENERICSETUP = False
    
from Globals import package_home
from Products.CMFCore import utils, CMFCorePermissions, DirectoryView
from Products.Archetypes.public import *
from Products.Archetypes import listTypes
from Products.Archetypes.utils import capitalize

import os, os.path

from Products.BernArticle.config import *

# Make the skins directories available as DirectoryViews.
DirectoryView.registerDirectory(SKINS_DIR, GLOBALS)
DirectoryView.registerDirectory('skins/BernArticle', GLOBALS)

def initialize(context):

    # import all custom content types:
    import content

    content_types, constructors, ftis = process_types(listTypes(PROJECTNAME), PROJECTNAME)

    utils.ContentInit(
        PROJECTNAME + ' Content',
        content_types      = content_types,
        permission         = ADD_CONTENT_PERMISSION,
        extra_constructors = constructors,
        fti                = ftis,
        ).initialize(context)

    if CustomizationPolicy and hasattr(CustomizationPolicy,'register'):
        CustomizationPolicy.register(context)
        print 'Customizationpolicy for BernArticle installed'
        
    if HAS_GENERICSETUP:
        profile_registry.registerProfile('BernArticle',
                'BernArticle',
                'Extension profile for default BernArticle setup',
                'profiles/default',
                'BernArticle',
                EXTENSION,
                for_=IPloneSiteRoot)
