from Products.CMFCore.CMFCorePermissions import AddPortalContent, ManagePortal
from Products.Archetypes.public import DisplayList

ADD_CONTENT_PERMISSION = AddPortalContent
MANAGE_PORTAL_PERMISSION = ManagePortal

PROJECTNAME      = "BernArticle"
SKINS_DIR        = "skins"              # base directory of the skins
SKIN_NAMES       = ('BernArticle', 'BernArticle_public', 'BernArticle_images', 'BernArticle_scripts')    # all skin folders go here

INSTALL_LINGUAPLONE = 0

GLOBALS = globals()
product_globals=globals()

PRODUCTLIST = [
    'BernArticle',
    ]

###################### some useful default settings:
    
DEFAULT_EMAIL_FROM_ADDRESS = 'webmaster@yourDomain.com'

DEFAULT_EMAIL_FROM_NAME = 'Portal Administrator'

PLATFORM_DEFAULT_LANGUAGE = 'de'

DEFAULT_AVAILABLE_EDITORS = ['Kupu',]
 
DEFAULT_NEW_ROLES = ('Administrator',)

LEFT_SLOTS = [
    'here/portlet_navigation/macros/portlet',
    'here/portlet_news/macros/portlet',
    'here/portlet_events/macros/portlet',
    'here/portlet_review/macros/portlet',
    'here/portlet_login/macros/portlet',
    ]   
    
RIGHT_SLOTS = [
    'here/portlet_bernarticle_block/macros/portlet',
    'here/portlet_bernarticle_news/macros/portlet',
    'here/portlet_bernarticle_event/macros/portlet',
    'here/portlet_bernarticle_file/macros/portlet',
    'here/portlet_bernarticle_link/macros/portlet',
    'here/portlet_bernarticle_article/macros/portlet',
    'here/portlet_bernarticle_about/macros/portlet',
    ]
    
    
###################### the types:
    
# These types are article types:
BERNARTICLE_ARTICLE_TYPES = [
    'BernArticle',
]


# These types are block types:
BERNARTICLE_BLOCK_TYPES = [
    'BernArticleBlock',
    'BernArticleBlockEvent',
    'BernArticleBlockFile',
    'BernArticleBlockLink',
    'BernArticleBlockList',
    'BernArticleBlockNews',
    'BernArticleBlockTeaser',
    ]    


# These types are collector types:
BERNARTICLE_COLLECTOR_TYPES = [
    'BernArticleCollector',
]


###################### properties of the types:

# These types are folder types:
BERNARTICLE_FOLDER_TYPES = [
    'BernArticle',
    'BernArticleCollector',
]


# These types function as special teaser blocks:
BERNARTICLE_TEASER_BLOCK_TYPES = [
    'BernArticleBlockTeaser',
    ]    


# These types can be handled by portal calendar tool:    
BERNARTICLE_CALENDAR_TYPES = [
    'BernArticleBlockEvent',
    ]        


BERNARTICLE_TYPES_FOR_SEARCH = [
    'BernArticle',
    'BernArticleCollector',
    'BernArticleBlock',
    'BernArticleBlockEvent',
    'BernArticleBlockFile',
    'BernArticleBlockLink',
    'BernArticleBlockList',
    'BernArticleBlockNews',
    'BernArticleBlockTeaser',
]


# These types are listable in the collector:
BERNARTICLE_TYPES_FOR_COLLECTOR = [
    'BernArticleBlockNews',
    'BernArticleBlockEvent',
    'BernArticleBlockFile',
    'BernArticleBlockLink',
]


# These types are block types:
BERNARTICLE_TYPES_FOR_ARTICLE_FOLDER_CONTENTS = [
    'BernArticleBlock',
    'BernArticleBlockFile',
    'BernArticleBlockEvent',
    'BernArticleBlockNews',
    'BernArticleBlockLink',
    'BernArticleBlockList',
    'BernArticleCollector',
    'BernArticle',
    'BernArticleBlockTeaser',
]


# These types should be hidden from navigation (menu, sitemap):
HIDDEN_FROM_NAVIGATION_METATYPES = [
     'BernArticleBlock',
     'BernArticleBlockEvent',
     'BernArticleBlockLink',
     'BernArticleBlockFile',
     'BernArticleBlockNews',
     'BernArticleBlockList',
     'BernArticleBlockTeaser',
]


# These types should be linkable objects inside kupu pane:
KUPU_LINKABLE_TYPES = ('BernArticle',
                 'BernArticleBlock',
                 'BernArticleBlockEvent',
                 'BernArticleBlockLink',
                 'BernArticleBlockList',
                 'BernArticleBlockFile',
                 'BernArticleBlockNews',
                 'BernArticleCollector',
                 ) 

# XXX Should be integrated into registry:
KUPU_DEFAULT_RESOURCE_TYPES = {
    'collection': ('Plone Site',
                   'Folder',
                   'Large Plone Folder',
                   'BernArticle',
                   'BernArticleBlockList',
                   'BernArticleCollector',
                   ),
    'mediaobject': ('Image',
                   ),
    'linkable': ('BernArticle',
                 'BernArticleBlock',
                 'BernArticleBlockEvent',
                 'BernArticleBlockLink',
                 'BernArticleBlockList',
                 'BernArticleBlockFile',
                 'BernArticleBlockNews',
                 'BernArticleCollector',
                 )
    }


##################### other definitions:
  
# These types should not be globaly addable:    
NOT_IMPLICITLY_ADDABLE = [
    'ATNewsItem',
    'ATEvent',
    'ATFile',
    'ATFolder',
    'ATImage',
    'ATFavorite',
    'ATLink',
    'ATTopic',
    'ATDocument',
    'News Item',
    'Event',
    'File',
    'Folder',
    'Image',
    'Favorite',
    'Link',
    'Topic',
    'ATRefBrowserDemo',
    ]

     
PREPOPULATE = [
     {'id':'events',
     'type':'BernArticleCollector',
     'title':'Events',
     'path':'',
     'types':'BernArticleBlockEvent', 
     },
      {'id':'news',
     'type':'BernArticleCollector',
     'title':'News',
     'path':'',
     'types':'BernArticleBlockNews',
     },    
    ]    

WELCOME_TEXT = """
<p>Welcome to the README for the Plone Product <strong>BernArticle</strong>.</p>

<h3>DESCRIPTION</h3>
<h4>        Functionality of BernArticle</h4>
<p>                BernArticle brings new content types and utilities into the Plone CMS.</p>
<p>                Main features of BernArticle are:</p>

<ul>
<li>BernArticle is a <em>folderish content type</em>, thus it can be used as the only
              object you need for structuring and editing contents of a website.
                  Other (normal) folder types are not needed when using BernArticle.</li>

<li>BernArticle allows very flexible content creation as it is composed
                  of <em>one or more individual content blocks</em>.</li>
<li>Each of these content blocks can have its <em>own layout</em> and can be <em>edited
                  indiviudally</em>.</li>
<li><em>New custom content block types</em> can easily be defined as new Archteypes.</li>
<li>A BernArticle can automatically show <em>summaries of contained BernArticles</em> (subarticles).</li>

</ul>
<h4>        Origin of BernArticle</h4>
<p>                BernArticle has its origin in a project, where 4teamwork implemented the Plone based
                CMS for the <a href="http://www.bern.ch">website of the city of Bern</a>, capital of Switzerland.</p>
<p>        Many thanks go to the city authorities who made BernArticle as an Open Source software possible.</p>
<h3>DOCUMENTATION</h3>
<p>        The documentation can be found in the subfolder "docs" of the product.</p>

<p>        Before installation please read at least the file "docs/INSTALL.txt".</p>
<h3>Have fun using BernArticle</h3>
<p>    The BernArticle maintainer team is looking forward to hear from you!
    <a href="mailto:info@4teamwork.ch">info@4teamwork.ch</a></p>
<p>    Copyright (C) 2004-2006 4teamwork Ltd., Bern, Switzerland and
    Informatikdienste of the city of Bern, Switzerland</p>
"""
