##############################################################################
#
# BernArticle - yet another Plone article...
#
# Copyright (C) 2005 4teamwork Ltd., Bern, Switzerland and
#                    Informatikdienste of the city of Bern, Switzerland
#
# GNU General Public Licence (GPL)
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307 USA
#
############################################################################## 

try:
    from Products.LinguaPlone.public import *
except ImportError: 
    # No multilingual support
    from Products.Archetypes.public import *
    
from AccessControl import ClassSecurityInfo
from Products.CMFCore  import CMFCorePermissions
from Products.CMFCore.TypesTool import TypesTool
from Products.CMFCore.utils import getToolByName

from Products.BernArticle.content.schemata.BernArticleBaseBlockSchema import BernArticleBaseBlock_schema
    
class BernArticleBaseBlock(BaseContent):
    security = ClassSecurityInfo()
    portal_type = meta_type = 'BernArticleBaseBlock'
    archetype_name = 'BernArticleBaseBlock'   #this name appears in the 'add' box
    allowed_content_types = []

    _at_rename_after_creation = True # rename object according to the title?
    
    schema = BaseSchema.copy() + BernArticleBaseBlock_schema  
    allow_discussion = 0
    content_icon = 'bernarticlebaseblock.gif'
    immediate_view = 'base_view'
    global_allow = 0
    filter_content_types = 1

    actions=  (
        {'action':     '''string:${object_url}/block_view''',
        'category':    '''object''',
        'id':          'view',
        'name':        'View',
        'permissions': (CMFCorePermissions.View,),
        'condition'  : 'python:1'},
              { 'id': 'edit',
                 'name': 'Edit',
                 'action': 'string:${object_url}/base_edit',
                 'condition': 'python: not hasattr(object,\'isTranslatable\') or hasattr(object,\'isTranslatable\') and object.isTranslatable() and object.isCanonical()',
                 'permissions': (CMFCorePermissions.ModifyPortalContent,),
                 },
               { 'id': 'translate',
                 'name': 'Edit',
                 'action': 'string:${object_url}/translate_item',
                 'condition': 'python: hasattr(object,\'isTranslatable\') and object.isTranslatable() and not object.isCanonical()',
                 'permissions': (CMFCorePermissions.ModifyPortalContent,),
                 },  
          )




    def _get_default_viewTemplate(self):
        try:
           return self.aq_parent.getViewTemplateName()
        except:
           return 'bernarticleblock_view_1'
      
    def get_image_size_2column(self,width,space):
        return int((width-space)/2)
        
    def get_image_size_3column(self,width,space):
        return int((width-(2*space))/3)
        
    def get_image_size_4column(self,width,space):
        return int((width-(3*space))/4)
        
    def get_image_sizes(self):
        ptool = getToolByName(self,'portal_properties', None)
        if ptool and hasattr(ptool, 'BernArticle_properties'):
            try:
               BernArticle_width = int(ptool.BernArticle_properties.getProperty('BernArticle_width', None))
            except:
               BernArticle_width = 530
            try:
               BernArticle_image_space = int(ptool.BernArticle_properties.getProperty('BernArticle_image_space', None))
            except:
               BernArticle_image_space = 10
            try:
               BernArticle_fixed_image_height = int(ptool.BernArticle_properties.getProperty('BernArticle_fixed_image_height', None))
            except:
               BernArticle_fixed_image_height = 150
        else:
            BernArticle_width = 530
            BernArticle_image_space = 10
        size2 = self.get_image_size_2column(BernArticle_width,BernArticle_image_space)
        size3 = self.get_image_size_3column(BernArticle_width,BernArticle_image_space)
        size4 = self.get_image_size_4column(BernArticle_width,BernArticle_image_space)
        return {'1column': (BernArticle_width, (BernArticle_width*2)), '2column': (size2, size2*2), '3column': (size3, size3*2), '4column': (size4, size4*2), '0column': (BernArticle_width, BernArticle_fixed_image_height)}
       
    
    security.declareProtected(CMFCorePermissions.View, 'position')
    def position(self):
      try:
        return self.aq_parent.getObjectPosition(self.id)
      except:
        return 0

    security.declareProtected(CMFCorePermissions.View, 'Title')
    def Title(self, **kwargs):
        """We have to override Title here to handle arbitrary
        arguments since PortalFolder defines it."""
        if self.Subheading():
          return self.Subheading()
        else:
          return '%s [%s]' % (self.aq_parent.title_or_id(),self.position())

registerType(BernArticleBaseBlock)


