##############################################################################
#
# BernArticle - yet another Plone article...
#
# Copyright (C) 2005 4teamwork Ltd., Bern, Switzerland and
#                    Informatikdienste of the city of Bern, Switzerland
#
# GNU General Public Licence (GPL)
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307 USA
#
############################################################################## 

try:
    from Products.LinguaPlone.public import *
except ImportError: 
    # No multilingual support
    from Products.Archetypes.public import *
from AccessControl import ClassSecurityInfo
from Products.BernArticle.BernArticleSafeHtml import html2safehtml
from Products.CMFCore import CMFCorePermissions

from BernArticleBaseBlock import BernArticleBaseBlock

from Products.BernArticle.content.schemata.BernArticleBlockSchema import BernArticleBlock_schema


class BernArticleBlock(BernArticleBaseBlock):
    """Basic content block consisting of text and up to 4 images."""

    security = ClassSecurityInfo()
    portal_type = meta_type = 'BernArticleBlock' 
    archetype_name = 'BernArticleBlock'   #this name appears in the 'add' box 
    allowed_content_types = [] + getattr(BernArticleBaseBlock,'allowed_content_types',[])

    _at_rename_after_creation = True # rename object according to the title?


    typeDescription= 'Basic content block consisting of text and up to 4 images.'
    typeDescMsgId  = 'bernarticle_description_edit_BernArticleBlock'

    content_icon = 'bernarticleblock.gif'

    schema = BernArticleBaseBlock.schema + BernArticleBlock_schema
    allow_discussion = 0

    immediate_view = 'base_view'
    global_allow = 0
    filter_content_types = 1
    
    #Methods
    
    security.declareProtected(CMFCorePermissions.View, 'tag')
    def tag(self, **kwargs):
        """Generate image tag using the api of the ImageField
        """
        return self.getField('image1').tag(self, **kwargs)
        
    security.declareProtected(CMFCorePermissions.View, 'Description')
    def Description(self, **kwargs):
        return self.getBlock_description()



registerType(BernArticleBlock)

