##############################################################################
#
# BernArticle - yet another Plone article...
#
# Copyright (C) 2005 4teamwork Ltd., Bern, Switzerland and
#                    Informatikdienste of the city of Bern, Switzerland
#
# GNU General Public Licence (GPL)
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307 USA
#
############################################################################## 

try:
    from Products.LinguaPlone.public import *
except ImportError: 
    # No multilingual support
    from Products.Archetypes.public import *
from AccessControl import ClassSecurityInfo
from Products.BernArticle.BernArticleSafeHtml import html2safehtml
from Products.CMFCore import CMFCorePermissions
from DateTime import DateTime
from Products.CMFCore.utils import getToolByName
from Products.ATReferenceBrowserWidget.ATReferenceBrowserWidget import *

from BernArticleBaseBlock import BernArticleBaseBlock

from Products.BernArticle.content.schemata.BernArticleBlockEventSchema import BernArticleBlockEvent_schema



class BernArticleBlockEvent(BernArticleBaseBlock):
    """Event content block consisting of text, up to 4 images and several specific event fields."""
    
    security = ClassSecurityInfo()
    portal_type = meta_type = 'BernArticleBlockEvent' 
    archetype_name = 'BernArticleBlockEvent'   #this name appears in the 'add' box 
    allowed_content_types = [] + getattr(BernArticleBaseBlock,'allowed_content_types',[])

    _at_rename_after_creation = True # rename object according to the title?

    typeDescription= 'Event content block consisting of text, up to 4 images and several specific event fields.'
    typeDescMsgId  = 'bernarticle_description_edit_BernArticleBlockEvent'

    allow_discussion = 0
    content_icon = 'bernarticleblockevent.gif'
    immediate_view = 'base_view'
    global_allow = 0
    filter_content_types = 1

    schema = BaseSchema + BernArticleBaseBlock.schema + BernArticleBlockEvent_schema 



    security.declareProtected(CMFCorePermissions.View, 'tag')
    def tag(self, **kwargs):
        """Generate image tag using the api of the ImageField
        """
        return self.getField('image1').tag(self, **kwargs) 
        
    security.declareProtected(CMFCorePermissions.View, 'Description')
    def Description(self, **kwargs):
        return self.getBlock_description()
        
    security.declareProtected(CMFCorePermissions.View, 'getEventTypes')
    def getEventTypes(self):
        """fetch a list of the available event types from the vocabulary
        """
        metatool = getToolByName(self, "portal_metadata")
        events = metatool.listAllowedSubjects(content_type = "Event")
        return events 

        

registerType(BernArticleBlockEvent)


