##############################################################################
#
# BernArticle - yet another Plone article...
#
# Copyright (C) 2005 4teamwork Ltd., Bern, Switzerland and
#                    Informatikdienste of the city of Bern, Switzerland
#
# GNU General Public Licence (GPL)
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307 USA
#
############################################################################## 
try:
    from Products.LinguaPlone.public import *
except ImportError: 
    # No multilingual support
    from Products.Archetypes.public import *
from AccessControl import ClassSecurityInfo
from Products.BernArticle.BernArticleSafeHtml import html2safehtml
from Products.CMFCore import CMFCorePermissions
from BernArticleBaseBlock import BernArticleBaseBlock

from Products.BernArticle.content.schemata.BernArticleBlockFileSchema import BernArticleBlockFile_schema



class BernArticleBlockFile(BernArticleBaseBlock):
    """File content block consisting of text, up to 4 images and a file."""

    security = ClassSecurityInfo()
    portal_type = meta_type = 'BernArticleBlockFile' 
    archetype_name = 'BernArticleBlockFile'   #this name appears in the 'add' box 
    allowed_content_types = [] + getattr(BernArticleBaseBlock,'allowed_content_types',[])

    _at_rename_after_creation = True # rename object according to the title?

    typeDescription= 'File content block consisting of text, up to 4 images and a file.'
    typeDescMsgId  = 'bernarticle_description_edit_BernArticleBlockFile'

    allow_discussion = 0
    content_icon = 'bernarticleblockfile.gif'
    immediate_view = 'base_view'
    global_allow = 0
    filter_content_types= 1

    schema = BaseSchema + BernArticleBaseBlock.schema + BernArticleBlockFile_schema


    
    security.declareProtected(CMFCorePermissions.View, 'Title')
    def Title(self, **kwargs):
        """We have to override Title here to handle arbitrary
        arguments since PortalFolder defines it."""
        try:
          if self.getName():
           return self.getName()
          elif self.getFile().filename:
           return self.getFile().filename
          else:
           return '%s [%s]' % (self.aq_parent.title_or_id(),self.position())   
        except:
           return '%s [%s]' % (self.aq_parent.title_or_id(),self.position())
    
    
    security.declareProtected(CMFCorePermissions.View, 'tag')
    def tag(self, **kwargs):
        """Generate image tag using the api of the ImageField
        """
        return self.getField('image1').tag(self, **kwargs)  

  
        

registerType(BernArticleBlockFile)


