##############################################################################
#
# BernArticle - yet another Plone article...
#
# Copyright (C) 2005 4teamwork Ltd., Bern, Switzerland and
#                    Informatikdienste of the city of Bern, Switzerland
#
# GNU General Public Licence (GPL)
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307 USA
#
############################################################################## 
try:
    from Products.LinguaPlone.public import *
except ImportError: 
    # No multilingual support
    from Products.Archetypes.public import *
from AccessControl import ClassSecurityInfo
from Products.BernArticle.BernArticleSafeHtml import html2safehtml
from Products.CMFCore import CMFCorePermissions
from Products.CMFCore.utils import getToolByName, _checkPermission
from BernArticleBaseBlock import BernArticleBaseBlock

from Products.BernArticle.content.schemata.BernArticleBlockListSchema import BernArticleBlockList_schema



class BernArticleBlockList(OrderedBaseFolder, BernArticleBaseBlock):
    """List content block consisting of text, up to 4 images and a collection of other conent blocks."""

    __implements__ = (OrderedBaseFolder.__implements__,
                      BernArticleBaseBlock.__implements__) 


    security = ClassSecurityInfo()
    portal_type = meta_type = 'BernArticleBlockList' 
    archetype_name = 'BernArticleBlockList'   #this name appears in the 'add' box 

    _at_rename_after_creation = True # rename object according to the title?

    typeDescription= 'List content block consisting of text, up to 4 images and a collection of other conent blocks.'
    typeDescMsgId  = 'bernarticle_description_edit_BernArticleBlockList'
    
    allowed_content_types = tuple()
    
    allow_discussion = 0
    content_icon = 'bernarticleblocklist.gif'
    immediate_view = 'base_view'
    global_allow = 0
    filter_content_types = 1

    schema = BaseSchema + BernArticleBaseBlock.schema + BernArticleBlockList_schema
    

    def _get_default_type(self):
           return 'BernArticleBlockFile'
    
    def allowedContentTypes(self):
        ''' return list of allowed content types '''
        result = []
        portal_types = getToolByName(self, 'portal_types')
        
        for contentType in portal_types.listTypeInfo():
                if contentType.getId() == self.getTypes():
                    result.append(contentType)
        
                   
        types = filter( lambda typ, container=self:
                       typ.isConstructionAllowed( container )
                       , result )
          
        return types  
              
    
    security.declareProtected(CMFCorePermissions.View, 'tag')
    def tag(self, **kwargs):
        """Generate image tag using the api of the ImageField
        """
        return self.getField('image1').tag(self, **kwargs) 
    
        
    security.declareProtected(CMFCorePermissions.View, 'Title')
    def Title(self, **kwargs):
        """We have to override Title here to handle arbitrary
        arguments since PortalFolder defines it."""
        try:
          if self.Subheading():
            return self.Subheading()
          else:
            return '%s [%s]' % (self.aq_parent.title_or_id(),self.position())
        except:
            return 'List [%s]' % (self.position())


    def get_types_for_collector(self):
        ptool = getToolByName(self,'portal_properties', None)
        types = []
        if ptool and hasattr(ptool, 'BernArticle_properties'):
            try:
               types = ptool.BernArticle_properties.getProperty('BernArticle_types_for_collector', None)
            except:
               types = []
           
        return types



registerType(BernArticleBlockList)


