##############################################################################
#
# BernArticle - yet another Plone article...
#
# Copyright (C) 2005 4teamwork Ltd., Bern, Switzerland and
#                    Informatikdienste of the city of Bern, Switzerland
#
# GNU General Public Licence (GPL)
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307 USA
#
############################################################################## 
try:
    from Products.LinguaPlone.public import *
except ImportError: 
    # No multilingual support
    from Products.Archetypes.public import *


from AccessControl import ClassSecurityInfo
from Products.BernArticle.BernArticleSafeHtml import html2safehtml
from Products.ATReferenceBrowserWidget.ATReferenceBrowserWidget import *
from Products.CMFCore import CMFCorePermissions
from Products.CMFCore.utils import getToolByName

from BernArticleBaseBlock import BernArticleBaseBlock

from Products.BernArticle.content.schemata.BernArticleBlockTeaserSchema import BernArticleBlockTeaser_schema



class BernArticleBlockTeaser(BernArticleBaseBlock):
    """A teaser block consisting of text, an image and a reference that leads to another content element."""

    security = ClassSecurityInfo()
    portal_type = meta_type = 'BernArticleBlockTeaser'
    archetype_name = 'BernArticleBlockTeaser'   #this name appears in the 'add' box
    allowed_content_types = []

    _at_rename_after_creation = True # rename object according to the title?

    typeDescription= 'A teaser block consisting of text, an image and a reference that leads to another content element.'
    typeDescMsgId  = 'bernarticle_description_edit_BernArticleBlockTeaser'

    allow_discussion = 0
    content_icon = 'bernarticleteaserblock.gif'
    immediate_view = 'base_view'
    global_allow = 0
    filter_content_types = 1

    schema = BaseSchema.copy() + BernArticleBlockTeaser_schema


    security.declareProtected(CMFCorePermissions.View, 'tag')
    def tag(self, **kwargs):
        """Generate image tag using the api of the ImageField
        """
        return self.getField('image1').tag(self, **kwargs)


    security.declareProtected(CMFCorePermissions.View, 'Description')
    def Description(self, **kwargs):
        return self.getBlock_description()
        
    def getShowImages(self):
        return 1


    def get_image_sizes(self):
        ptool = getToolByName(self,'portal_properties', None)
        if ptool and hasattr(ptool, 'BernArticle_properties'):
            try:
               BernArticle_width = int(ptool.BernArticle_properties.getProperty('BernArticle_width', None))
            except:
               BernArticle_width = 530
            try:
               BernArticle_image_space = int(ptool.BernArticle_properties.getProperty('BernArticle_image_space', None))
            except:
               BernArticle_image_space = 10
            try:
                BernArticle_startpageblock_width = int(ptool.BernArticle_properties.getProperty('BernArticle_startpageblock_width', None))
            except:
                BernArticle_startpageblock_width = 70
        else:
            BernArticle_width = 530
            BernArticle_image_space = 10
            BernArticle_startpageblock_width = 50
        size2 = self.get_image_size_2column(BernArticle_width,BernArticle_image_space)
        size3 = self.get_image_size_3column(BernArticle_width,BernArticle_image_space)
        size4 = self.get_image_size_4column(BernArticle_width,BernArticle_image_space)
        return {'thumbnail': (BernArticle_startpageblock_width, BernArticle_startpageblock_width*2),'1column': (BernArticle_width, (BernArticle_width*2)), '2column': (size2, size2*2), '3column': (size3, size3*2), '4column': (size4, size4*2)}




registerType(BernArticleBlockTeaser)


