##############################################################################
#
# BernArticle - yet another Plone article...
#
# Copyright (C) 2005 4teamwork Ltd., Bern, Switzerland and
#                    Informatikdienste of the city of Bern, Switzerland
#
# GNU General Public Licence (GPL)
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307 USA
#
############################################################################## 
try:
    from Products.LinguaPlone.public import *
except ImportError: 
    # No multilingual support
    from Products.Archetypes.public import *
 
 
from ZPublisher.HTTPRequest import HTTPRequest   
from AccessControl import ClassSecurityInfo
from Products.Archetypes.Marshall import RFC822Marshaller
from Products.CMFCore import CMFCorePermissions
from Products.CMFCore.utils import getToolByName, _checkPermission
from Products.ATReferenceBrowserWidget.ATReferenceBrowserWidget import *
from Products.BernArticle.config import *

from Products.BernArticle.content.schemata.BernArticleCollectorSchema import BernArticleCollector_schema


class BernArticleCollector(OrderedBaseFolder):
    """A Collector can show all content blocks of a specific type and that match a search."""
    
    security = ClassSecurityInfo()
    portal_type = meta_type = 'BernArticleCollector'
    archetype_name = 'BernArticleCollector'   #this name appears in the 'add' box 

    _at_rename_after_creation = True # rename object according to the title?

    typeDescription= 'A Collector can show all content blocks of a specific type and that match a search.'
    typeDescMsgId  = 'bernarticle_description_edit_BernArticleCollector'

    schema = BaseSchema.copy() + BernArticleCollector_schema

    allowed_content_types = tuple()
    allow_discussion = 0
    content_icon = 'bernarticlecollector.gif'
    immediate_view = 'base_view'
    global_allow = 1
    filter_content_types = 1


    actions=  (
        {
        'id': 'view',
        'name': 'View',
        'action': 'string:${object_url}/bernarticlecollector_view',
        'permissions': (CMFCorePermissions.View,)
        },
        {
        'id': 'preview',
        'name': 'Preview',
        'condition': 'python: not hasattr(object.REQUEST,\'preview\')',
        'action': 'string:${object_url}/bernarticlecollector_view?preview=1',
        'permissions': (CMFCorePermissions.ModifyPortalContent,)
        },
         {
        'id': 'layout-view',
        'name': 'Preview',
        'condition': 'python: hasattr(object.REQUEST,\'preview\')',
        'action': 'string:${object_url}/bernarticlecollector_view',
        'permissions': (CMFCorePermissions.ModifyPortalContent,)
        },
              { 'id': 'edit',
                 'name': 'Edit',
                 'action': 'string:${object_url}/base_edit',
                 'condition': 'python: not hasattr(object,\'isTranslatable\') or hasattr(object,\'isTranslatable\') and object.isTranslatable() and object.isCanonical()',
                 'permissions': (CMFCorePermissions.ModifyPortalContent,),
                 },
               { 'id': 'translate',
                 'name': 'Edit',
                 'action': 'string:${object_url}/translate_item',
                 'condition': 'python: hasattr(object,\'isTranslatable\') and object.isTranslatable() and not object.isCanonical()',
                 'permissions': (CMFCorePermissions.ModifyPortalContent,),
                 }, 
        {
        'id': 'local_roles',
        'name': 'Sharing',
        'action': 'string:${object_url}/folder_localrole_form',
        'permissions': (CMFCorePermissions.ManageProperties,),
        'category': 'object'
        },           
         
    )        



    def _get_default_viewTemplate(self):
        try:
           return self.aq_parent.getViewTemplateName()
        except:
           return 'bernarticleblock_view_4_1l'
           
           
    def _get_default_type(self):
           return 'BernArticleBlockNews'
        
        
    def get_image_size_2column(self,width,space):
        return int((width-space)/2)
        
    def get_image_size_3column(self,width,space):
        return int((width-(2*space))/3)
        
    def get_image_size_4column(self,width,space):
        return int((width-(3*space))/4)
        
    def get_image_sizes(self):
        ptool = getToolByName(self,'portal_properties', None)
        if ptool and hasattr(ptool, 'BernArticle_properties'):
            try:
               BernArticle_width = int(ptool.BernArticle_properties.getProperty('BernArticle_width', None))
            except:
               BernArticle_width = 530
            try:
               BernArticle_image_space = int(ptool.BernArticle_properties.getProperty('BernArticle_image_space', None))
            except:
               BernArticle_image_space = 10
        else:
            BernArticle_width = 530
            BernArticle_image_space = 10
        size2 = self.get_image_size_2column(BernArticle_width,BernArticle_image_space)
        size3 = self.get_image_size_3column(BernArticle_width,BernArticle_image_space)
        size4 = self.get_image_size_4column(BernArticle_width,BernArticle_image_space)
        return {'1column': (BernArticle_width, (BernArticle_width*2)), '2column': (size2, size2*2), '3column': (size3, size3*2), '4column': (size4, size4*2)}


    security.declareProtected(CMFCorePermissions.View, 'tag')
    def tag(self, **kwargs):
        """Generate image tag using the api of the ImageField
        """
        return self.getField('image1').tag(self, **kwargs)  
        
        
    def allowedContentTypes(self):
        ''' return list of allowed content types '''
        result = []
        portal_types = getToolByName(self, 'portal_types')
        
        for contentType in portal_types.listTypeInfo():
                if contentType.getId() == self.getTypes():
                    result.append(contentType)
        
                   
        types = filter( lambda typ, container=self:
                       typ.isConstructionAllowed( container )
                       , result )
          
        return types 


    security.declareProtected(CMFCorePermissions.ModifyPortalContent, 'setPath_restriction')
    def setPath_restriction(self,value):
        if self.getPath_restriction_ref() is not None:
            self.Schema()['path_restriction'].set(self, '/'.join(self.getPath_restriction_ref().getPhysicalPath()))
        else:
            self.Schema()['path_restriction'].set(self, '')


    def list_all_subjects(self):
        return self.portal_catalog.uniqueValuesFor('Subject')

        
    def get_types_for_collector(self):
        ptool = getToolByName(self,'portal_properties', None)
        types = []
        if ptool and hasattr(ptool, 'BernArticle_properties'):
            try:
               types = ptool.BernArticle_properties.getProperty('BernArticle_types_for_collector', None)
            except:
               types = []
        return types


registerType(BernArticleCollector)


