##############################################################################
#
# BernArticle - yet another Plone article...
#
# Copyright (C) 2005 4teamwork Ltd., Bern, Switzerland and
#                    Informatikdienste of the city of Bern, Switzerland
#
# GNU General Public Licence (GPL)
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307 USA
#
############################################################################## 

try:
    from Products.LinguaPlone.public import *
except ImportError: 
    # No multilingual support
    from Products.Archetypes.public import *


from DateTime import DateTime
from Products.ATReferenceBrowserWidget.ATReferenceBrowserWidget import *
from Products.ATContentTypes.permission import ChangeEvents

BernArticleBlockEvent_schema = Schema((

     StringField('subheading',
             required=1,
             default='',
             searchable=1,
             accessor='Subheading',
             widget=StringWidget(label_msgid="label_title",
                                 description_msgid="help_title",
                                 i18n_domain="plone"),
        ), 
                
                   
      TextField('block_description',
              default='',
              searchable=1,
              storage=MetadataStorage(),
              widget = TextAreaWidget(rows = 5,
                                      label_msgid="label_description",
                                      description_msgid="help_description",
                                      label="Description",
                                      description="Enter a description",
                                      i18n_domain="plone")),
     
    
    DateTimeField('startDate',
                  languageIndependent = 1,
                  required = 1,
                  searchable = 1,
                  accessor='start',
                  default=DateTime(),
                  widget = CalendarWidget(description="Enter the starting date and time, or click the calendar icon and select it. ",
                                          description_msgid = "help_event_start",
                                          label="Event Starts",
                                          label_msgid = "label_event_start",
                                          i18n_domain = "plone")),

    DateTimeField('endDate',
                  languageIndependent = 1,
                  required = 1,
                  searchable = 1,
                  accessor='end',
                  default=DateTime(),
                  widget = CalendarWidget(description= "Enter the ending date and time, or click the calendar icon and select it. ",
                                          description_msgid = "help_event_end",
                                          label = "Event Ends",
                                          label_msgid = "label_event_end",
                                          i18n_domain = "plone")),
                                          
    
                                          
    StringField('location',
                searchable = 1,
                widget = StringWidget(description = "Enter the location where the event will take place.",
                                      description_msgid = "help_event_location",
                                      label = "Event Location",
                                      label_msgid = "label_event_location",
                                      i18n_domain = "bernarticle")),
    StringField('contactName',
                required=0,
                searchable = 1,
                accessor='contact_name',
                widget = StringWidget(description = "Enter a contact person or organization for the event.",
                                      description_msgid = "help_contact_name",
                                      label = "Contact Name",
                                      label_msgid = "label_contact_name",
                                      i18n_domain = "bernarticle")),
    StringField('contactPhone',
                required=0,
                searchable = 1,
                accessor='contact_phone',
                validators = ('isInternationalPhoneNumber',),
                widget = StringWidget(description = "Enter the phone number to call for information and/or booking.",
                                      description_msgid = "help_contact_phone",
                                      label = "Contact Phone",
                                      label_msgid = "label_contact_phone",
                                      i18n_domain = "bernarticle")),
    StringField('contactEmail',
                required=0,
                searchable = 1,
                accessor='contact_email',
                validators = ('isEmail',),
                widget = StringWidget(description = "Enter an e-mail address to use for information regarding the event.",
                                      description_msgid = "help_contact_email",
                                      label = "Contact E-mail",
                                      label_msgid = "label_contact_email",
                                      i18n_domain = "bernarticle")),
    
    LinesField('attendees',
               languageIndependent=True,
               searchable=True,
               write_permission=ChangeEvents,
               widget=LinesWidget(label="Attendees",
                                  label_msgid="label_event_attendees",
                                  description=(" "),
                                  description_msgid="help_event_attendees",
                                  i18n_domain="plone")),
                                       
    LinesField('eventType',
               required=False,
               searchable=True,
               write_permission = ChangeEvents,
               vocabulary = 'getEventTypes',
               languageIndependent=True,
               widget = MultiSelectionWidget(
                        size = 6,
                        description="",
                        description_msgid = "help_event_type",
                        label = "Event Type(s)",
                        label_msgid = "label_event_type",
                        i18n_domain = "plone")),
                                                                             
    StringField('eventUrl',
                required=0,
                languageIndependent = 1,
                searchable = 1,
                accessor='event_url',
                validators = ('isURL',),
                widget = StringWidget(description = "Enter the optional web address of a page containing more info about the event. ",
                                      description_msgid = "help_url",
                                      label = "Event URL",
                                      label_msgid = "label_url",
                                      i18n_domain = "bernarticle")),
   
    

      TextField('text',
                  searchable = 1,
                  default_content_type='text/html',
                  default_output_type='text/html',
                  validators=('isTidyHtmlWithCleanup',),
                  allowable_content_types=('text/structured',
                                           'text/html'),
                  widget=RichWidget(description='Enter a value for text.',
                                        description_msgid='BernArticle_help_text',
                                        i18n_domain='bernarticle',
                                        label='Text',
                                        label_msgid='BernArticle_label_text',
                                        rows = 20,                                        
                                        ),
        ),       
      

           DateTimeField('effectiveDate',
            languageIndependent = 1,
            mutator = 'setEffectiveDate',
            default_method = DateTime,
            widget=CalendarWidget(
                label="Effective Date",
                description=("Date when the content should become available "
                             "on the public site"),
                label_msgid="label_effective_date",
                description_msgid="help_effective_date",
                i18n_domain="bernarticle"),
        ),
        
       DateTimeField(
            'expirationDate',
            mutator='setExpirationDate',
            languageIndependent = True,
            widget=CalendarWidget(
                label="Expiration Date",
                description=("Date when the content should no longer be "
                             "visible on the public site"),
                label_msgid="label_expiration_date",
                description_msgid="help_expiration_date",
                i18n_domain="bernarticle"),
        ),
        
        ReferenceField('relatedItems',
                    relationship='relatesTo',
                    schemata = 'Related items',
                    multiValued = 1,
                    allowed_types = (),                    
                    widget = ReferenceBrowserWidget(description = "Select the related items",
                                                    description_msgid = "help_related_items",
                                                    label = "Related items",
                                                    label_msgid = "label_relatet_items",
                                                    i18n_domain = "plone",)),         

    ),
    )