##############################################################################
#
# BernArticle - yet another Plone article...
#
# Copyright (C) 2005 4teamwork Ltd., Bern, Switzerland and
#                    Informatikdienste of the city of Bern, Switzerland
#
# GNU General Public Licence (GPL)
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307 USA
#
############################################################################## 

try:
    from Products.LinguaPlone.public import *
except ImportError: 
    # No multilingual support
    from Products.Archetypes.public import *


from DateTime import DateTime
from Products.ATReferenceBrowserWidget.ATReferenceBrowserWidget import *



BernArticleBlockList_schema = Schema((
                   
    TextField('text',
                  searchable = 1,
                  default_content_type='text/html',
                  default_output_type='text/html',
                  validators=('isTidyHtmlWithCleanup',),
                  allowable_content_types=('text/structured',
                                           'text/html'),
                  widget=RichWidget(description='Enter a value for text.',
                                        description_msgid='BernArticle_help_text',
                                        i18n_domain='bernarticle',
                                        label='Text',
                                        label_msgid='BernArticle_label_text',
                                        rows = 20,                                        
                                        ),
        ),


       StringField('types',
            languageIndependent=1,
            required=1,
            default_method='_get_default_type',
            vocabulary='get_types_for_collector',
            widget=SelectionWidget(description='Enter the Type to list',
                                   format='radio',
                                   description_msgid='bernarticlecollector_types_help',
                                   i18n_domain='bernarticle',
                                   label='Type',
                                   label_msgid='bernarticlecollector_types_label',),
        ),

        
         BooleanField('portlet',
                languageIndependent = 1,
                default=0,
                schemata = 'Portlet',
                widget=BooleanWidget(
                      visible={'view':'invisible', 'edit':'invisible'},
                      label='Block as Portlet',
                      label_msgid='label_portlet_choice',
                       description="Set to display block as a porlet",
                       description_msgid='help_portlet_choice',
                       i18n_domain='bernarticle',
                    ),
                ),
                
        BooleanField('show_picture_in_portlet',
                languageIndependent = 1,
                default=1,
                schemata = 'Portlet',
                widget=BooleanWidget(
                      visible={'view':'invisible', 'edit':'invisible'},
                      label='Show Image',
                      label_msgid='label_image_choice',
                       description="Set to display images in listing",
                       description_msgid='help_image_choice',
                       i18n_domain='bernarticle',
                    ),
                ),
        
    ),
    )