##############################################################################
#
# BernArticle - yet another Plone article...
#
# Copyright (C) 2005 4teamwork Ltd., Bern, Switzerland and
#                    Informatikdienste of the city of Bern, Switzerland
#
# GNU General Public Licence (GPL)
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307 USA
#
############################################################################## 

try:
    from Products.LinguaPlone.public import *
except ImportError: 
    # No multilingual support
    from Products.Archetypes.public import *


from DateTime import DateTime
from Products.ATReferenceBrowserWidget.ATReferenceBrowserWidget import *



BernArticleBlockNews_schema = Schema((
    
      StringField('subheading',
             required=0,
             default='',
             searchable=1,
             accessor='Subheading',
             widget=StringWidget(label_msgid="label_title",
                                 label="Title",
                                 description="Enter a title",
                                 description_msgid="help_title",
                                 i18n_domain="plone"),
        ), 

          TextField('block_description',
              default='',
              searchable=1,
              storage=MetadataStorage(),
              widget = TextAreaWidget(rows = 5,
                                      label_msgid="label_description",
                                      description_msgid="help_description",
                                      label="Description",
                                      description="Enter a description",
                                      i18n_domain="plone")),
              
              
        TextField('text',
                  searchable = 1,
                  default_content_type='text/html',
                  default_output_type='text/html',
                  validators=('isTidyHtmlWithCleanup',),
                  allowable_content_types=('text/structured',
                                           'text/html'),
                  widget=RichWidget(description='Enter a value for text.',
                                        description_msgid='BernArticle_help_text',
                                        i18n_domain='bernarticle',
                                        label='Text',
                                        label_msgid='BernArticle_label_text',
                                        rows = 20,                                        
                                        ),
        ),
        
        
        DateTimeField('effectiveDate',
            languageIndependent = 1,
            mutator = 'setEffectiveDate',
            default_method = DateTime,
            widget=CalendarWidget(
                label="Effective Date",
                description=("Date when the content should become available "
                             "on the public site"),
                label_msgid="label_effective_date",
                description_msgid="help_effective_date",
                i18n_domain="bernarticle"),
        ),
        
       DateTimeField(
            'expirationDate',
            mutator='setExpirationDate',
            languageIndependent = True,
            #default=CEILING_DATE,
            widget=CalendarWidget(
                label="Expiration Date",
                description=("Date when the content should no longer be "
                             "visible on the public site"),
                label_msgid="label_expiration_date",
                description_msgid="help_expiration_date",
                i18n_domain="bernarticle"),
        ),
        
         ReferenceField('relatedItems',
                    relationship='relatesTo',
                    schemata = 'Related items',
                    multiValued = 1,
                    allowed_types = (),                    
                    widget = ReferenceBrowserWidget(description = "Select the related items",
                                                    description_msgid = "help_related_items",
                                                    label = "Related items",
                                                    label_msgid = "label_relatet_items",
                                                    i18n_domain = "plone",)), 
 

    ),
    )