##############################################################################
#
# BernArticle - yet another Plone article...
#
# Copyright (C) 2005 4teamwork Ltd., Bern, Switzerland and
#                    Informatikdienste of the city of Bern, Switzerland
#
# GNU General Public Licence (GPL)
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307 USA
#
############################################################################## 

try:
    from Products.LinguaPlone.public import *
except ImportError: 
    # No multilingual support
    from Products.Archetypes.public import *

from DateTime import DateTime
from Products.ATReferenceBrowserWidget.ATReferenceBrowserWidget import *

BernArticleBlockTeaser_schema = Schema((
    
         StringField('title',
             required=0,
             default='',
             searchable=1,
             accessor='Title',
             widget=StringWidget(label_msgid="label_title",
                                 description_msgid="help_title",
                                 visible={'view' : 'invisible',
                                          'edit' : 'hidden'},
                                 i18n_domain="plone"),
        ),
        
    StringField('description',
             required=0,
             default='',
             searchable=0,
             widget=StringWidget(visible={'view' : 'invisible',
                                          'edit' : 'hidden'},
                                 ),
        ),


        StringField('subheading',
             required=0,
             default='',
             searchable=1,
             accessor='Subheading',
             widget=StringWidget(label_msgid="label_title",
                                 description_msgid="help_title",
                                 i18n_domain="bernarticle"),
        ),

        StringField('id',
                required=0, ## Still actually required, but
                            ## the widget will supply the missing value
                            ## on non-submits
                mode="rw",
                accessor="getId",
                mutator="setId",
                default=None,
                widget=IdWidget(label="Short Name",
                                label_msgid="label_short_name",
                                description="Should not contain spaces, underscores or mixed case. "\
                                "Short Name is part of the item's web address.",
                                description_msgid="help_shortname",
                                visible={'view' : 'invisible', 'edit' : 'hidden'},
                                i18n_domain="plone"),
                                ),

        
        ImageField('image1',
            languageIndependent = 1,
            schemata='Image1',
            original_size=(1060,1060),
            sizes="get_image_sizes",
            storage=AttributeStorage(),
            widget=ImageWidget(description='Enter a value for image1.',
                description_msgid='BernArticleBlock_help_image1',
                i18n_domain='bernarticle',
                label='Image1',
                label_msgid='BernArticleBlock_label_image1',
            ),
        ),


        TextField('block_description',
              default='',
              searchable=1,
              storage=MetadataStorage(),
              widget = TextAreaWidget(rows = 5,
                                      label_msgid="label_description",
                                      description_msgid="help_description",
                                      label="Description",
                                      description="Enter a description",
                                      i18n_domain="plone")),


        TextField('text',
                  searchable = 1,
                  default_content_type='text/html',
                  default_output_type='text/html',
                  validators=('isTidyHtmlWithCleanup',),
                  allowable_content_types=('text/structured',
                                           'text/html'),
                  widget=RichWidget(description='Enter a value for text.',
                                        description_msgid='BernArticle_help_text',
                                        i18n_domain='bernarticle',
                                        label='Text',
                                        label_msgid='BernArticle_label_text',
                                        rows = 20,
                                        ),
        ),

     ReferenceField('relatedItem',
                    relationship='relatesToItem',
                    multiValued = 0,
                    allowed_types = (),
                    widget = ReferenceBrowserWidget(description = "Select the related item",
                                                    description_msgid = "help_related_item",
                                                    label = "Related item",
                                                    label_msgid = "label_relatet_item",
                                                    i18n_domain = "plone",)),

    ),
    )
