##############################################################################
#
# BernArticle - yet another Plone article...
#
# Copyright (C) 2005 4teamwork Ltd., Bern, Switzerland and
#                    Informatikdienste of the city of Bern, Switzerland
#
# GNU General Public Licence (GPL)
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307 USA
#
############################################################################## 

try:
    from Products.LinguaPlone.public import *
except ImportError: 
    # No multilingual support
    from Products.Archetypes.public import * 

from ElementaryBernArticleEffectiveDateSchema import ElementaryBernArticleEffectiveDate_schema
from ElementaryBernArticleContentSchema import ElementaryBernArticleContent_schema
from ElementaryBernArticleLayoutSchema import ElementaryBernArticleLayout_schema
from ElementaryBernArticleListingSchema import ElementaryBernArticleListing_schema
from ElementaryBernArticleImage1Schema import ElementaryBernArticleImage1_schema
from ElementaryBernArticleImage2Schema import ElementaryBernArticleImage2_schema
from ElementaryBernArticleImage3Schema import ElementaryBernArticleImage3_schema
from ElementaryBernArticleImage4Schema import ElementaryBernArticleImage4_schema
from ElementaryBernArticleBannerSchema import ElementaryBernArticleBanner_schema
from ElementaryBernArticleRelatedSchema import ElementaryBernArticleRelated_schema
from ElementaryBernArticleExcludeFromNavSchema import ElementaryBernArticleExcludeFromNav_schema


BernArticle_schema = ElementaryBernArticleEffectiveDate_schema + \
                     ElementaryBernArticleContent_schema + \
                     ElementaryBernArticleLayout_schema + \
                     ElementaryBernArticleListing_schema + \
                     ElementaryBernArticleImage1_schema + \
                     ElementaryBernArticleImage2_schema + \
                     ElementaryBernArticleImage3_schema + \
                     ElementaryBernArticleImage4_schema + \
                     ElementaryBernArticleBanner_schema + \
                     ElementaryBernArticleRelated_schema + \
                     ElementaryBernArticleExcludeFromNav_schema + \
                     Schema((

         StringField('viewCollectorListingName',
            languageIndependent=1,
            schemata="Listing",
            required=1,
            default='bernarticle_collector_listing_0',
            vocabulary=DisplayList((('bernarticle_collector_listing_0', 'No Listing'),
                                    ('bernarticle_collector_listing_1', 'Same Listing as for Subarticles'),                              
                                    )), 
           widget=SelectionWidget(description='Enter a value for listing type.',
                                   format='radio',
                                   description_msgid='BernArticle_help_viewCollectorListingName',
                                   i18n_domain='bernarticle',
                                   label='Listing of Collectors',
                                   label_msgid='BernArticle_label_viewCollectorListingName',),
                                   ),



 
))

# correct the position of the new fields in the schemata:
BernArticle_schema.moveField('viewCollectorListingName', after='show_ListingImages')