##############################################################################
#
# BernArticle - yet another Plone article...
#
# Copyright (C) 2005 4teamwork Ltd., Bern, Switzerland and
#                    Informatikdienste of the city of Bern, Switzerland
#
# GNU General Public Licence (GPL)
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307 USA
#
############################################################################## 

try:
    from Products.LinguaPlone.public import *
except ImportError: 
    # No multilingual support
    from Products.Archetypes.public import *



ElementaryBernArticleBlockContent_schema = Schema((


         StringField('title',
             required=0,
             default='',
             searchable=1,
             accessor='Title',
             widget=StringWidget(label_msgid="label_title",
                                 description_msgid="help_title",
                                 visible={'view' : 'invisible',
                                          'edit' : 'hidden'},
                                 i18n_domain="plone"),
        ),


        StringField('description',
             required=0,
             default='',
             searchable=0,
             widget=StringWidget(visible={'view' : 'invisible',
                                          'edit' : 'hidden'},
                                 ),
        ),


        StringField('subheading',
             required=0,
             default='',
             searchable=1,
             accessor='Subheading',
             widget=StringWidget(label_msgid="label_title",
                                 description_msgid="help_title",
                                 i18n_domain="bernarticle"),
        ), 

        
        StringField('id',
                required=0, ## Still actually required, but
                            ## the widget will supply the missing value
                            ## on non-submits
                mode="rw",
                accessor="getId",
                mutator="setId",
                default=None,
                widget=IdWidget(label="Short Name",
                                label_msgid="label_short_name",
                                description="Should not contain spaces, underscores or mixed case. "\
                                "Short Name is part of the item's web address.",
                                description_msgid="help_shortname",
                                visible={'view' : 'invisible', 'edit' : 'hidden'},
                                i18n_domain="plone"),
                                ),

        
        TextField('block_description',
              default='',
              searchable=1,
              storage=MetadataStorage(),
              widget = TextAreaWidget(rows = 5,
                                      label_msgid="label_description",
                                      description_msgid="help_description",
                                      label="Description",
                                      description="Enter a description",
                                      i18n_domain="plone")),                                                    

  
),)