##############################################################################
#
# BernArticle - yet another Plone article...
#
# Copyright (C) 2005 4teamwork Ltd., Bern, Switzerland and
#                    Informatikdienste of the city of Bern, Switzerland
#
# GNU General Public Licence (GPL)
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307 USA
#
############################################################################## 

try:
    from Products.LinguaPlone.public import *
except ImportError: 
    # No multilingual support
    from Products.Archetypes.public import *

from Products.ATReferenceBrowserWidget.ATReferenceBrowserWidget import *


ElementaryBernArticleCollectorTypes_schema = Schema((

        
       StringField('types',
            languageIndependent=1,
            required=1,
            default_method='_get_default_type',
            vocabulary='get_types_for_collector',
            widget=SelectionWidget(description='Enter the Type to list',
                                   format='radio',
                                   description_msgid='bernarticlecollector_types_help',
                                   i18n_domain='bernarticle',
                                   label='Type',
                                   label_msgid='bernarticlecollector_types_label',),
        ),
        
        
        ReferenceField('path_restriction_ref',
                    schemata="Restrictions",
                    relationship='restrictedPathTo',
                    #languageIndependent = 1,
                    allowed_types = (),
                    multiValued = 0,
                    widget = ReferenceBrowserWidget(  label = 'Path Restriction',
                                            label_msgid = 'bernarticle_path_restriction_label',
                                            i18n_domain = 'bernarticle',
                                            description = 'Enter a path to a folder for restricting query to this folder and subfolders',
                                            description_msgid = 'bernarticle_path_restriction_description',
                                            force_close_on_insert = 1,),
                   ),

                   
        StringField('path_restriction',
                    schemata="Restrictions",
                    #languageIndependent = 1,
                    widget = StringWidget( visible={'view' : 'invisible',
                                                    'edit' : 'hidden'}),
                   ),

                   
        LinesField('subject_restriction',
                    default=[],
                    schemata="Restrictions",
                    languageIndependent = 1,
                    vocabulary = 'list_all_subjects',
                    widget = MultiSelectionWidget(  label = 'Subject Restriction',
                                            label_msgid = 'bernarticle_subject_restriction_label',
                                            i18n_domain = 'bernarticle',
                                            description = 'Enter a subject for restricting query',
                                            description_msgid = 'bernarticle_subject_restriction_description',),
                   ),

                   
        IntegerField('batch_size',
                    searchable = 1,
                    default = 10,
                    schemata="Restrictions",
                    languageIndependent = 1,
                    widget = StringWidget(  label = 'Batch Size',
                                            label_msgid = 'bernarticle_batch_size_label',
                                            i18n_domain = 'bernarticle',
                                            description = 'Enter number of items per page',
                                            description_msgid = 'bernarticle_batch_size_description',),
                   ),
                           
        
),)