##############################################################################
#
# BernArticle - yet another Plone article...
#
# Copyright (C) 2005 4teamwork Ltd., Bern, Switzerland and
#                    Informatikdienste of the city of Bern, Switzerland
#
# GNU General Public Licence (GPL)
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307 USA
#
############################################################################## 

try:
    from Products.LinguaPlone.public import *
except ImportError: 
    # No multilingual support
    from Products.Archetypes.public import *



ElementaryBernArticleLayout_schema = Schema((

        
        StringField('viewTemplateName',
            languageIndependent=1,
            schemata="Layout",
            required=1,
            default_method='_get_default_viewTemplate',
            vocabulary=DisplayList((('bernarticleblock_view_1', '1 column (image first, then text)'),
                                    ('bernarticleblock_view_2_1l', '2 columns, image on the left'),
                                    ('bernarticleblock_view_2_1r', '2 columns, image on the right'),
                                    ('bernarticleblock_view_2_2', '2 columns, 2 images'),                                    
                                    ('bernarticleblock_view_3_1l', '3 columns, image on the left'),
                                    ('bernarticleblock_view_3_1r', '3 columns, image on the right'),
                                    ('bernarticleblock_view_3_3', '3 columns, 3 images'),
                                    ('bernarticleblock_view_4_1l', '4 columns, image on the left'),
                                    ('bernarticleblock_view_4_1r', '4 columns, image on the right'),
                                    ('bernarticleblock_view_4_2l', '4 columns, 2 images on the left'),
                                    ('bernarticleblock_view_4_2r', '4 columns, 2 images on the right'),
                                    ('bernarticleblock_view_4_4', '4 columns, 4 images'),
                                    ('bernarticleblock_view_float_pic_left', 'Text area flexible, 1 image on the left'),
                                    ('bernarticleblock_view_float_pic_right', 'Text area flexible, 1 image on the right'),
                                    ('bernarticleblock_view_4_fixed_height', '4 images with fixed height'),
                                    )), 
           widget=SelectionWidget(description='Enter a value for viewTemplateName.',
                                  format='radio',
                                  macro='BernArticle_widgets/visualselection',
                                  description_msgid='BernArticleBlock_help_viewTemplateName',
                                  i18n_domain='bernarticle',
                                  label='View template',
                                  label_msgid='BernArticleBlock_label_viewTemplateName',),
        ),

        
        BooleanField('showImages',
                languageIndependent = 1,
                default=1,
                schemata = 'Layout',
                widget=BooleanWidget(
                      label='Show images of this article/block.',
                      label_msgid='label_showimages',
                       description="Set to display the images of this article/block.",
                       description_msgid='help_showimages',
                       i18n_domain='bernarticle',
                    ),
        ),
     
),)